diff --git a/iccom_driver.c b/iccom_driver.c
index f2219aa..a9552f1 100644
--- a/iccom_driver.c
+++ b/iccom_driver.c
@@ -22,640 +9,491 @@
 #include <linux/errno.h>
 #include <linux/of_address.h>
 #include <linux/uaccess.h>
-#include <linux/spinlock.h>
-#include <linux/semaphore.h>
 #include <linux/mutex.h>
 #include <linux/wait.h>
 #include <linux/interrupt.h>
 #include <linux/delay.h>
 #include <linux/version.h>
 
-#include "iccom.h"
-#include "iccom_core.h"
-#include "iccom_driver.h"
-
-static int32_t iccom_drv_open(struct iccom *iccom,
-				struct iccom_channel **channel_out);
-static ssize_t iccom_drv_read(struct iccom_channel *channel,
-				struct iccom_cmd *cmd);
-static ssize_t iccom_drv_write(struct iccom_channel *channel,
-				struct iccom_cmd *cmd);
-static int32_t iccom_drv_ioctl(struct iccom_channel *channel,
-				int32_t req, void *arg);
-static int32_t iccom_drv_close(struct iccom_channel *channel);
-static irqreturn_t iccom_drv_isr(int irq, void *dev_id);
-static int32_t iccom_drv_write_mfis(struct iccom_channel *channel,
-				uint32_t write_data, size_t msg_size);
-static int32_t iccom_drv_poll_int_clear(uint32_t *iicr_add, int32_t timer);
-static int32_t iccom_drv_probe(struct platform_device *pdev);
-static int32_t iccom_drv_remove(struct platform_device *pdev);
-static int32_t iccom_drv_init(void);
-static void iccom_drv_exit(void);
-static void iccom_drv_device_release(struct device *dev);
-static void iccom_drv_release_channel(struct iccom_channel *channel);
-static void iccom_drv_release_iccom(struct iccom *iccom, uint8_t request_flg);
-
-static int32_t iccom_drv_poll_int_clear(uint32_t *iicr_add, int32_t timer)
+#include "iccom_ioctl.h"
+#include "iccom_internal.h"
+
+#define ICCOM_POLLING_PERIOD_US		(1000U)
+
+#define ICCOM_REQUEST_IICR		(0x01U)
+#define ICCOM_REQUEST_EICR		(0x02U)
+#define ICCOM_REQUEST_IMBR		(0x04U)
+#define ICCOM_REQUEST_EMBR		(0x08U)
+#define ICCOM_REQUEST_CTA		(0x10U)
+#define ICCOM_REQUEST_IRQ		(0x20U)
+#define ICCOM_REQUEST_ALL		(0x3FU)
+
+#define ICCOM_MFIS_LEN			(4U)
+#define ICCOM_REG_OFFSET_LEN		(16)
+#define ICCOM_CTA_MEMORY_LEN		(16)
+
+// IMPORTANT: Keep these masks aligned between CA55 and G4MH
+#define ICCOM_CTRL_INT				(0x00000001U)
+#define ICCOM_CTRL_BUFF_UPPER		(0x00000002U)
+#define ICCOM_CTRL_BUFF_BOTTOM		(0x00000004U)
+#define ICCOM_CTRL_DATA				(0x00000008U)
+#define ICCOM_CTRL_ACK				(0x00000010U)
+#define ICCOM_CTRL_INIT_COMPLETED	(0x00000020U)
+
+#define IICR_SEND_DATA	(ICCOM_CTRL_DATA | ICCOM_CTRL_BUFF_BOTTOM | ICCOM_CTRL_INT)
+#define IICR_SEND_ACK	(ICCOM_CTRL_ACK | ICCOM_CTRL_BUFF_UPPER | ICCOM_CTRL_INT)
+
+#define ICCOM_MODULE_NAME		"ICCOM driver"
+#define ICCOM_MAX_NAME_LENGTH	128
+
+// Return all the relevant registers to a known initial state
+static void iccom_drv_reset_registers(
+							struct iccom_communication_info *iccom_comm)
 {
-	int32_t i;
-	uint32_t check_mfis;
-	int32_t ret;
+	iowrite32(0x00, iccom_comm->mfis_imbr_addr);
+	iowrite32(0x00, iccom_comm->mfis_iicr_addr);
+	iowrite32(0x00, iccom_comm->mfis_embr_addr);
+	iowrite32(0x00, iccom_comm->mfis_eicr_addr);
+}
 
-	pr_debug("%s: Start\n", __func__);
+// Update IICR and IMBR in order to signal G4 that there is some data/ack to read
+static void iccom_drv_write_iicr_imbr(
+					struct iccom_communication_info *iccom_comm,
+					uint32_t iicr_val, uint32_t imbr_val)
+{
+	iowrite32(imbr_val, iccom_comm->mfis_imbr_addr);
+	iowrite32(iicr_val, iccom_comm->mfis_iicr_addr);
+}
 
-	for (i = 0; i < timer; i++) {
-		check_mfis = ioread32(iicr_add);
-		if ((check_mfis & ICCOM_CTRL_INT) == 0U) {
-			break;
+// Clear the EICR in order to let G4 know that we received the message (data/ack)
+static void iccom_drv_clear_eicr(struct iccom_communication_info *iccom_comm)
+{
+	iowrite32(0x00, iccom_comm->mfis_eicr_addr);
+}
+
+// Wait for the IICR's bit 0 (interrupt) to be cleared on the G4 side. This
+// function is used when interrupts are disabled, i.e. during "open" or
+// inside the ISR handling thread
+static int32_t iccom_drv_poll_int_clear(struct iccom *iccom)
+{
+	int32_t i;
+	uint32_t iicr_val;
+	struct iccom_communication_info *iccom_comm = iccom->comm_info;
+
+	for (i = 0; i < iccom->hw_info.int_clear_timeout; i++) {
+		iicr_val = ioread32(iccom_comm->mfis_iicr_addr);
+		if ((iicr_val & ICCOM_CTRL_INT) == 0U) {
+			return 0;
 		}
-		usleep_range(ICCOM_WAIT_TIMER_US, ICCOM_WAIT_TIMER_US + 1U);
+		usleep_range(ICCOM_POLLING_PERIOD_US, ICCOM_POLLING_PERIOD_US + 1U);
 	}
 
-	if (i < timer) {
-		ret = ICCOM_OK;
-	} else {
-		ret = -EDEADLK;
-	}
+	// reset registers to a default state
+	iccom_drv_reset_registers(iccom_comm);
 
-	pr_debug("%s: End ret = %d, count = %d\n", __func__, ret, i);
+	dev_err(iccom->dev, "[Err] Operation timed out\n");
 
-	return ret;
+	return -EDEADLK;
 }
 
-static int32_t iccom_drv_write_mfis(struct iccom_channel *channel,
-				uint32_t write_data, size_t msg_size)
+static void iccom_drv_release_comm(struct iccom_communication_info *iccom_comm)
 {
-	int32_t ret;
-	struct iccom_communication_info *iccom_comm;
-	struct iccom_hardware_info *iccom_hw;
+	if (iccom_comm != NULL) {
+		if (iccom_comm->bottom_addr != NULL) {
+			iounmap(iccom_comm->bottom_addr);
+		}
 
-	pr_debug("%s: Start write_data = 0x%x, msg_size = %zd\n",
-		__func__, write_data, msg_size);
+		if (iccom_comm->upper_addr != NULL) {
+			iounmap(iccom_comm->upper_addr);
+		}
 
-	iccom_comm = (struct iccom_communication_info *)channel->priv;
-	iccom_hw = (struct iccom_hardware_info *)channel->iccom->priv;
+		if (iccom_comm->mfis_embr_addr != NULL) {
+			iounmap(iccom_comm->mfis_embr_addr);
+		}
 
-	mutex_lock(&iccom_comm->mutex_poll_intbit);
+		if (iccom_comm->mfis_imbr_addr != NULL) {
+			iounmap(iccom_comm->mfis_imbr_addr);
+		}
 
-	ret = iccom_drv_poll_int_clear(iccom_comm->mfis_iicr_addr,
-					iccom_hw->trg_timeout);
-	if (ret == ICCOM_OK) {
-		iowrite32(msg_size, iccom_comm->mfis_imbr_addr);
-		iowrite32(write_data, iccom_comm->mfis_iicr_addr);
+		if (iccom_comm->mfis_eicr_addr != NULL) {
+			iounmap(iccom_comm->mfis_eicr_addr);
+		}
+
+		if (iccom_comm->mfis_iicr_addr != NULL) {
+			iounmap(iccom_comm->mfis_iicr_addr);
+		}
 	}
+}
 
-	mutex_unlock(&iccom_comm->mutex_poll_intbit);
+static void iccom_drv_release_hw(struct iccom *iccom, uint8_t request_flg)
+{
+	struct iccom_hardware_info *iccom_hw = &(iccom->hw_info);
 
-	pr_debug("%s: End ret = %d\n", __func__, ret);
+	if (iccom_hw != NULL) {
+		if ((request_flg & ICCOM_REQUEST_IICR) != 0U) {
+			release_mem_region((uintptr_t)iccom_hw->mfis_iicr_addr,
+					ICCOM_MFIS_LEN);
+		}
+		if ((request_flg & ICCOM_REQUEST_EICR) != 0U) {
+			release_mem_region((uintptr_t)iccom_hw->mfis_eicr_addr,
+					ICCOM_MFIS_LEN);
+		}
+		if ((request_flg & ICCOM_REQUEST_IMBR) != 0U) {
+			release_mem_region((uintptr_t)iccom_hw->mfis_imbr_addr,
+					ICCOM_MFIS_LEN);
+		}
+		if ((request_flg & ICCOM_REQUEST_EMBR) != 0U) {
+			release_mem_region((uintptr_t)iccom_hw->mfis_embr_addr,
+					ICCOM_MFIS_LEN);
+		}
+		if ((request_flg & ICCOM_REQUEST_CTA) != 0U) {
+			release_mem_region((uintptr_t)iccom_hw->cta_addr,
+					(uintptr_t)iccom_hw->cta_size);
+		}
+		if ((request_flg & ICCOM_REQUEST_IRQ) != 0U) {
+			free_irq(iccom_hw->irq_no, (void *)iccom);
+		}
+	}
+}
 
-	return ret;
+static __maybe_unused void dump_buffer(uint8_t* buf, size_t len)
+{
+	size_t i = 0;
+	char line[50] = { 0 };
+	char* ptr;
+
+	while (true) {
+		if ( ((i % 16) == 0) || (i >= len) ) {
+			printk("%s", line);
+			memset(line, 0, sizeof(line));
+			ptr = line;
+			if (i >= len) {
+				return;
+			}
+		}
+		ptr += sprintf(ptr, "%02x ", buf[i]);
+		i++;
+	}
 }
 
-static int32_t iccom_drv_open(struct iccom *iccom,
-				struct iccom_channel **channel_out)
+static int32_t iccom_drv_open(struct iccom *iccom)
 {
-	int32_t ret = ICCOM_OK;
-	struct iccom_channel *l_channel = NULL;
+	int32_t ret = 0;
 	struct iccom_communication_info *iccom_comm = NULL;
 	struct iccom_hardware_info *iccom_hw;
-	uint32_t write_iicr;
-	uint32_t copy_eicr;
 	void __iomem *remap_addr;
 
 	dev_dbg(iccom->dev, "%s: Start\n", __func__);
 
-	mutex_lock(&iccom->mutex_channel_open);
-	if ((iccom->flg & ICCOM_FLG_CH_OPEN) == 0U) {
-		pr_debug("Open route\n");
-		iccom->flg |= ICCOM_FLG_CH_OPEN;
-		mutex_unlock(&iccom->mutex_channel_open);
-		l_channel = (struct iccom_channel *)devm_kzalloc(
-			iccom->dev,
-			sizeof(struct iccom_channel) +
-			sizeof(struct iccom_communication_info),
-			GFP_KERNEL);
-		if (l_channel == NULL) {
-			ret = -ENOMEM;
-			dev_err(iccom->dev, "[Err]No enough memory\n");
-		}
-	} else {
-		ret = -EBUSY;
-		dev_err(iccom->dev, "[Err]This channel already open\n");
-		mutex_unlock(&iccom->mutex_channel_open);
+	if (iccom->is_open) {
+		dev_err(iccom->dev, "[Err] This channel already open\n");
+		return -EINVAL;
 	}
 
-	if (ret == ICCOM_OK) {
-		l_channel->iccom = iccom;
-		l_channel->priv = &l_channel[1];
-
-		iccom_comm = (struct iccom_communication_info *)l_channel->priv;
-		iccom_hw = (struct iccom_hardware_info *)iccom->priv;
-
-		iccom_comm->read_status = ICCOM_READ_STATE_WAIT_READ;
-		iccom_comm->write_status[ICCOM_CTA_UPPER] =
-						ICCOM_WRITE_STATE_WAIT_WRITE;
-		iccom_comm->write_status[ICCOM_CTA_BOTTOM] =
-						ICCOM_WRITE_STATE_WAIT_WRITE;
-
-		(void)memset(&iccom_comm->ack_arrive, 0,
-				sizeof(iccom_comm->ack_arrive));
-		(void)memset(&iccom_comm->recv_index, 0,
-				sizeof(iccom_comm->recv_index));
-		(void)memset(&iccom_comm->recv_eicr, 0,
-				sizeof(iccom_comm->recv_eicr));
-		(void)memset(&iccom_comm->recv_embr, 0,
-				sizeof(iccom_comm->recv_embr));
-		(void)memset(&iccom_comm->ack_embr, 0,
-				sizeof(iccom_comm->ack_embr));
-		(void)memset(&iccom_comm->cta_flg, 0,
-				sizeof(iccom_comm->cta_flg));
-
-		sema_init(&iccom_comm->sem_send_cta, ICCOM_CTA_SBUF_NUM);
-		mutex_init(&iccom_comm->mutex_poll_intbit);
-		spin_lock_init(&iccom_comm->spinlock_mfis_info);
-
-		spin_lock_init(&iccom_comm->spinlock_cta_flg);
-
-		init_waitqueue_head(&iccom_comm->write_q);
-		init_waitqueue_head(&iccom_comm->read_q);
-		init_waitqueue_head(&iccom_comm->ioctl_q);
-		iccom_comm->close_flg = 0;
-
-		remap_addr = ioremap_nocache(
-			(uintptr_t)iccom_hw->mfis_iicr_addr, ICCOM_MFIS_LEN);
-		if (remap_addr == NULL) {
-			dev_err(iccom->dev, "[Err]Remap IICR failed\n");
-			ret = -ENOMEM;
-		} else {
-			iccom_comm->mfis_iicr_addr = (uint32_t *)remap_addr;
-		}
+	iccom->comm_info = (struct iccom_communication_info*) devm_kzalloc(
+							iccom->dev,
+							sizeof(struct iccom_communication_info),
+							GFP_KERNEL);
+	if (IS_ERR(iccom->comm_info)) {
+		dev_err(iccom->dev, "[Err] Cannot allocate iccom_communication_info\n");
+		return -ENOMEM;
+	}
 
-		remap_addr = ioremap_nocache(
-			(uintptr_t)iccom_hw->mfis_eicr_addr, ICCOM_MFIS_LEN);
-		if (remap_addr == NULL) {
-			dev_err(iccom->dev, "[Err]Remap EICR failed\n");
-			ret = -ENOMEM;
-		} else {
-			iccom_comm->mfis_eicr_addr = (uint32_t *)remap_addr;
-		}
+	iccom_comm = iccom->comm_info;
+	iccom_hw = &(iccom->hw_info);
 
-		remap_addr = ioremap_nocache(
-			(uintptr_t)iccom_hw->mfis_imbr_addr, ICCOM_MFIS_LEN);
-		if (remap_addr == NULL) {
-			dev_err(iccom->dev, "[Err]Remap IMBR failed\n");
-			ret = -ENOMEM;
-		} else {
-			iccom_comm->mfis_imbr_addr = (uint32_t *)remap_addr;
-		}
+	mutex_init(&iccom_comm->comm_mutex);
 
-		remap_addr = ioremap_nocache(
-			(uintptr_t)iccom_hw->mfis_embr_addr, ICCOM_MFIS_LEN);
-		if (remap_addr == NULL) {
-			dev_err(iccom->dev, "[Err]Remap EMBR failed\n");
-			ret = -ENOMEM;
-		} else {
-			iccom_comm->mfis_embr_addr = (uint32_t *)remap_addr;
-		}
+	init_waitqueue_head(&iccom_comm->write_q);
+	init_waitqueue_head(&iccom_comm->read_q);
 
-		remap_addr = ioremap_nocache((uintptr_t)iccom_hw->cta_addr,
-				iccom_hw->cta_size);
-		if (remap_addr == NULL) {
-			dev_err(iccom->dev, "[Err]Remap CTA failed\n");
-			ret = -ENOMEM;
-		} else {
-			iccom_comm->cta_addr = (uint8_t *)remap_addr;
-		}
+	remap_addr = ioremap(iccom_hw->mfis_iicr_addr, ICCOM_MFIS_LEN);
+	if (remap_addr == NULL) {
+		dev_err(iccom->dev, "[Err] Remap IICR failed\n");
+		return -ENOMEM;
 	}
+	iccom_comm->mfis_iicr_addr = (uint32_t *)remap_addr;
 
-	if (ret == ICCOM_OK) {
-		dev_dbg(iccom->dev, "flg check: 0x%X\n",
-			(iccom->flg & ICCOM_FLG_CH_INIT_END));
-		if ((iccom->flg & ICCOM_FLG_CH_INIT_END) == 0U) {
-			write_iicr =
-				(ICCOM_CTRL_INIT_END | ICCOM_CTRL_INT);
-			iowrite32(write_iicr,
-				iccom_comm->mfis_iicr_addr);
-
-			mutex_lock(&iccom_comm->mutex_poll_intbit);
-			ret = iccom_drv_poll_int_clear(
-				iccom_comm->mfis_iicr_addr,
-				iccom_hw->trg_timeout);
-			mutex_unlock(&iccom_comm->mutex_poll_intbit);
-			if (ret == ICCOM_OK) {
-				iccom->flg |= ICCOM_FLG_CH_INIT_END;
-			} else {
-				ret = -EDEADLK;
-				dev_err(iccom->dev,
-					"[Err] Channel init EDEADLK\n");
-			}
-		}
+	remap_addr = ioremap(iccom_hw->mfis_eicr_addr, ICCOM_MFIS_LEN);
+	if (remap_addr == NULL) {
+		dev_err(iccom->dev, "[Err] Remap EICR failed\n");
+		return -ENOMEM;
 	}
+	iccom_comm->mfis_eicr_addr = (uint32_t *)remap_addr;
 
-	if (ret == ICCOM_OK) {
-		*channel_out = l_channel;
-		iccom->channel = l_channel;
-
-		/*
-		 * Discard the interrupt received prior to the
-		 * open process is completed.
-		 */
-		copy_eicr = ioread32(iccom_comm->mfis_eicr_addr);
-		iowrite32((copy_eicr & ICCOM_CTRL_CLEAR_INIT_BIT),
-			iccom_comm->mfis_eicr_addr);
-		enable_irq(iccom_hw->irq_no);
-
-		dev_dbg(iccom->dev, "iccom_communication_info\n");
-		dev_dbg(iccom->dev, "mfis_iicr_addr = %p\n",
-			iccom_comm->mfis_iicr_addr);
-		dev_dbg(iccom->dev, "mfis_eicr_addr = %p\n",
-			iccom_comm->mfis_eicr_addr);
-		dev_dbg(iccom->dev, "mfis_imbr_addr = %p\n",
-			iccom_comm->mfis_imbr_addr);
-		dev_dbg(iccom->dev, "mfis_embr_addr = %p\n",
-			iccom_comm->mfis_embr_addr);
-		dev_dbg(iccom->dev, "cta_addr = %p\n", iccom_comm->cta_addr);
-	} else {
-		if (ret != -EBUSY) {
-			mutex_lock(&iccom->mutex_channel_open);
-			iccom->flg &= ~ICCOM_FLG_CH_OPEN;
-			mutex_unlock(&iccom->mutex_channel_open);
-			if (l_channel != NULL) {
-				iccom_drv_release_channel(l_channel);
-			}
-		}
+	remap_addr = ioremap(iccom_hw->mfis_imbr_addr, ICCOM_MFIS_LEN);
+	if (remap_addr == NULL) {
+		dev_err(iccom->dev, "[Err] Remap IMBR failed\n");
+		return -ENOMEM;
+	}
+	iccom_comm->mfis_imbr_addr = (uint32_t *)remap_addr;
+
+	remap_addr = ioremap(iccom_hw->mfis_embr_addr, ICCOM_MFIS_LEN);
+	if (remap_addr == NULL) {
+		dev_err(iccom->dev, "[Err] Remap EMBR failed\n");
+		return -ENOMEM;
 	}
-	dev_dbg(iccom->dev, "%s: End ret = %d\n", __func__, ret);
+	iccom_comm->mfis_embr_addr = (uint32_t *)remap_addr;
+
+	iccom_comm->max_transaction_size = iccom_hw->cta_size/2;
+
+	remap_addr = ioremap(iccom_hw->bottom_addr, iccom_comm->max_transaction_size);
+	if (remap_addr == NULL) {
+		dev_err(iccom->dev, "[Err] Remap bottom CTA failed\n");
+		return -ENOMEM;
+	}
+	iccom_comm->bottom_addr = (uint8_t *)remap_addr;
+
+	remap_addr = ioremap(iccom_hw->upper_addr, iccom_comm->max_transaction_size);
+	if (remap_addr == NULL) {
+		dev_err(iccom->dev, "[Err] Remap upper CTA failed\n");
+		return -ENOMEM;
+	}
+	iccom_comm->upper_addr = (uint8_t *)remap_addr;
+
+	iccom->comm_info->rx_data_buff = (uint8_t*) devm_kzalloc(
+					iccom->dev,
+					iccom_comm->max_transaction_size,
+					GFP_KERNEL);
+	if (IS_ERR(iccom->comm_info->rx_data_buff)) {
+		dev_err(iccom->dev, "[Err] Cannot allocate rx_data_buff\n");
+		return -ENOMEM;
+	}
+	iccom->comm_info->valid_rx_data = 0;
+
+	iccom_drv_reset_registers(iccom_comm);
+
+	// Signal that the initialization is completed
+	iccom_drv_write_iicr_imbr(iccom_comm,
+				ICCOM_CTRL_INIT_COMPLETED | ICCOM_CTRL_INT, 0);
+
+	ret = iccom_drv_poll_int_clear(iccom);
+	if (ret != 0) {
+		dev_err(iccom->dev, "[Err] Initialization not Acked\n");
+		return -EDEADLK;
+	}
+
+	iccom_drv_reset_registers(iccom_comm);
+	enable_irq(iccom->hw_info.irq_no);
 
 	return ret;
 }
 
-static ssize_t iccom_drv_read(struct iccom_channel *channel,
-				struct iccom_cmd *cmd)
+static int32_t iccom_drv_read(struct iccom *iccom, uint8_t *buf, uint32_t count)
 {
 	struct iccom_communication_info *iccom_comm;
-	int32_t ret_poll;
-	uint32_t set_info;
-	enum iccom_cta_area cta_sw;
-	int32_t err_wait;
-	uintptr_t irq_flg = 0UL;
-	ssize_t ret = ICCOM_OK;
-	uint8_t *tgt_addr;
-	int64_t ret_cpy = 0;
-	int32_t ret_access;
-	uint32_t recv_i;
-
-	pr_debug("%s: Start\n", __func__);
-	iccom_comm = (struct iccom_communication_info *)channel->priv;
-
-	if (iccom_comm->read_status == ICCOM_READ_STATE_SEND_ACK) {
-		pr_debug("Send ACK\n");
-		cta_sw = iccom_comm->recv_index[0];
-		set_info = (cta_sw << ICCOM_SHIFT_SET_ACK_AREA);
-		set_info |= ICCOM_CTRL_INT;
-
-		/* Organize MFIS information */
-		spin_lock_irqsave(&iccom_comm->spinlock_mfis_info, irq_flg);
-		for (recv_i = 0U; recv_i < (ICCOM_CTA_RBUF_NUM - 1); recv_i++) {
-			iccom_comm->recv_index[recv_i] =
-				iccom_comm->recv_index[recv_i + 1U];
-		}
-		iccom_comm->data_arrive--;
-		spin_unlock_irqrestore(&iccom_comm->spinlock_mfis_info,
-					irq_flg);
-
-		ret_poll = iccom_drv_write_mfis(channel, set_info,
-			iccom_comm->recv_embr[cta_sw]);
-		if (ret_poll != ICCOM_OK) {
-			iccom_comm->read_status = ICCOM_READ_STATE_WAIT_READ;
-			ret = -EDEADLK;
-			dev_err(channel->iccom->dev, "[Err]Send Ack failed\n");
-		}
+	int32_t ret = 0;
+	unsigned long copy_ret;
+	uint32_t read_data = 0;
+
+	iccom_comm = iccom->comm_info;
+
+	mutex_lock(&iccom_comm->comm_mutex);
+
+	if (iccom_comm->valid_rx_data == 0) {
+		dev_err(iccom->dev, "[Err] No data to read\n");
+		ret = -ENODATA;
+		goto Exit;
 	}
 
-	if (ret == ICCOM_OK) {
-		if (iccom_comm->data_arrive == 0U) {
-			iccom_comm->read_status = ICCOM_READ_STATE_RECEIVING;
-		}
-		pr_debug("Wait read\n");
-		err_wait = wait_event_interruptible(iccom_comm->read_q,
-			((iccom_comm->data_arrive >= 1) ||
-				iccom_comm->close_flg == 1));
-		if (err_wait < 0) {
-			ret = -EINTR;
-		} else if (iccom_comm->data_arrive == 0) {
-			pr_debug("read close flg = %d\n",
-				iccom_comm->close_flg);
-			/* Iccom_lib_Final() is called and all ACK is sended. */
-			iccom_comm->close_flg = 2;
-			wake_up_interruptible(&iccom_comm->ioctl_q);
-			ret = -ECANCELED;
-		} else {
-			cta_sw = iccom_comm->recv_index[0];
-			cmd->count = iccom_comm->recv_embr[cta_sw];
-			tgt_addr = (iccom_comm->cta_addr +
-				((cta_sw + ICCOM_CTA_SBUF_NUM) *
-					ICCOM_BUF_MAX_SIZE));
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(5, 0, 0)
-			ret_access = access_ok(cmd->buf, cmd->count);
-#else
-			ret_access = access_ok(VERIFY_WRITE, cmd->buf,
-					cmd->count);
-#endif
-			if (ret_access != 0) {
-				dev_dbg(channel->iccom->dev,
-					"copy_to_user route\n");
-				ret_cpy = copy_to_user(cmd->buf, tgt_addr,
-							cmd->count);
-			} else {
-				dev_dbg(channel->iccom->dev,
-					"memcpy route\n");
-				memcpy_fromio(cmd->buf, tgt_addr, cmd->count);
-			}
+	if (!access_ok(buf, iccom_comm->max_transaction_size)) {
+		dev_err(iccom->dev, "[Err] Cannot access output buffer while reading");
+		ret = -EIO;
+		goto Exit;
+	}
 
-			if (ret_cpy == 0) {
-				iccom_comm->read_status =
-					ICCOM_READ_STATE_SEND_ACK;
-				ret = cmd->count;
-			}
-		}
+	if (count < iccom_comm->valid_rx_data) {
+		dev_err(iccom->dev, "[Err] Provided buffer is %d in size, but read data is %d",
+				count, iccom_comm->valid_rx_data);
+		ret = -EINVAL;
+		goto Exit;
+	}
+
+	copy_ret = copy_to_user(buf, iccom_comm->rx_data_buff,
+				iccom_comm->valid_rx_data);
+	if (copy_ret > 0) {
+		dev_err(iccom->dev, "[Err] Cannot copy data to userspace");
+		ret = -EIO;
+		goto Exit;
 	}
+	read_data = iccom_comm->valid_rx_data;
 
-	pr_debug("%s: End ret = %zd\n", __func__, ret);
+	//dump_buffer(iccom_comm->rx_data_buff,
+	//	(iccom_comm->valid_rx_data < 32) ? iccom_comm->valid_rx_data : 32);
 
-	return ret;
+	iccom_comm->valid_rx_data = 0;
+	memset(iccom_comm->rx_data_buff, 0, iccom_comm->max_transaction_size);
+
+	dev_dbg(iccom->dev, "Returning %d bytes\n", count);
+
+Exit:
+	mutex_unlock(&iccom_comm->comm_mutex);
+
+	if (ret < 0) {
+		return ret;
+	}
+	return read_data;
 }
 
-static ssize_t iccom_drv_write(struct iccom_channel *channel,
-				struct iccom_cmd *cmd)
+static int32_t iccom_drv_write(struct iccom *iccom, uint8_t *buf, uint32_t count)
 {
 	struct iccom_communication_info *iccom_comm;
 	struct iccom_hardware_info *iccom_hw;
-	int32_t ret_pall;
-	enum iccom_cta_area cta_sw = ICCOM_CTA_UPPER;
-	uint32_t mfis_set_info;
-	int32_t err;
 	ssize_t ret = 0;
-	int64_t ret_cpy = 0;
 	uint8_t *tgt_addr;
-	enum iccom_cta_area snd_area;
-	uintptr_t irq_flg = 0UL;
+	unsigned long copy_ret;
 
-	pr_debug("%s: Start cmd->cnt = %zd\n", __func__, cmd->count);
+	iccom_comm = iccom->comm_info;
+	iccom_hw = &(iccom->hw_info);
 
-	iccom_comm = (struct iccom_communication_info *)channel->priv;
-	iccom_hw = (struct iccom_hardware_info *)channel->iccom->priv;
+	mutex_lock(&iccom_comm->comm_mutex);
 
-	if (down_trylock(&iccom_comm->sem_send_cta) != 0) {
-		pr_err("[Err]No CTA semaphore\n");
-		ret = -ENOSPC;
-	} else {
-		spin_lock_irqsave(&iccom_comm->spinlock_cta_flg, irq_flg);
-		for (snd_area = 0; snd_area < ICCOM_CTA_COUNT; snd_area++) {
-			if ((iccom_comm->cta_flg[snd_area] == 0U) &&
-				(iccom_comm->write_status[snd_area] ==
-						ICCOM_WRITE_STATE_WAIT_WRITE)) {
-				cta_sw = snd_area;
-				iccom_comm->cta_flg[cta_sw] = 1U;
-				break;
-			}
-		}
-		spin_unlock_irqrestore(&iccom_comm->spinlock_cta_flg, irq_flg);
-
-		if (snd_area >= ICCOM_CTA_COUNT) {
-			pr_err("[Err]CTA area is all used\n");
-			ret = -ENOSPC;
-		} else {
-			pr_debug("CTA%d write\n", cta_sw);
-
-			tgt_addr = (iccom_comm->cta_addr +
-				(cta_sw * ICCOM_BUF_MAX_SIZE));
-			dev_dbg(channel->iccom->dev,
-				"memcpy_toio : "
-				"tgt_addr = %p, buf = %p,"
-				" count = %lu\n", (void *)tgt_addr,
-				(void *)cmd->buf, cmd->count);
-				memcpy_toio(tgt_addr, cmd->buf, cmd->count);
-
-			if (ret_cpy == 0) {
-				dev_dbg(channel->iccom->dev, "Write success\n");
-				mfis_set_info = ((cta_sw
-						<< ICCOM_SHIFT_SET_SEND_AREA)
-						| (ICCOM_CTRL_INT
-						| ICCOM_CTRL_SND_ACK));
-				pr_debug("mfis set info :0x%X\n",
-						mfis_set_info);
-				iccom_comm->ack_arrive[cta_sw] = 0U;
-				iccom_comm->write_status[cta_sw] =
-						ICCOM_WRITE_STATE_RECV_ACK;
-				ret_pall = iccom_drv_write_mfis(channel,
-						mfis_set_info, cmd->count);
-				if (ret_pall != ICCOM_OK) {
-					dev_err(channel->iccom->dev,
-						"[Err]Write EDEADLK\n");
-					spin_lock_irqsave(
-						&iccom_comm->spinlock_cta_flg,
-						irq_flg);
-					iccom_comm->cta_flg[cta_sw] = 0U;
-					spin_unlock_irqrestore(
-						&iccom_comm->spinlock_cta_flg,
-						irq_flg);
-					ret = -EDEADLK;
-				} else {
-					pr_debug("Wait ack\n");
-					err = wait_event_interruptible_timeout(
-						iccom_comm->write_q,
-						(iccom_comm->ack_arrive[cta_sw]
-							== 1),
-						iccom_hw->ack_timeout_jf);
-					if (err == 0) {
-						ret = -ETIMEDOUT;
-					} else if (err < 0) {
-						ret = -EINTR;
-					} else {
-						ret
-						 = iccom_comm->ack_embr[cta_sw];
-					}
-				}
-				iccom_comm->write_status[cta_sw] =
-						ICCOM_WRITE_STATE_WAIT_WRITE;
-			} else {
-				spin_lock_irqsave(&iccom_comm->spinlock_cta_flg,
-							irq_flg);
-				iccom_comm->cta_flg[cta_sw] = 0U;
-				spin_unlock_irqrestore(
-						&iccom_comm->spinlock_cta_flg,
-						irq_flg);
-			}
-		}
-		up(&iccom_comm->sem_send_cta);
+	iccom_comm->ack_received = 0;
+	iccom_comm->valid_rx_data = 0;
+	memset(iccom_comm->rx_data_buff, 0, iccom_comm->max_transaction_size);
+	iccom_drv_reset_registers(iccom_comm);
+
+	tgt_addr = iccom_comm->bottom_addr;
+ 
+	if (!access_ok(buf, count)) {
+		dev_err(iccom->dev, "[Err] Cannot access output buffer while writing");
+		ret = -EIO;
+		goto Exit;
+	}
+	copy_ret = copy_from_user(tgt_addr, buf, count);
+	if (copy_ret > 0) {
+		dev_err(iccom->dev, "[Err] Cannot copy data from userspace");
+		ret = -EIO;
+		goto Exit;
 	}
 
-	pr_debug("%s: End ret = %zd\n", __func__, ret);
+	//dump_buffer(tgt_addr, count);
+
+	dev_dbg(iccom->dev, "Sending message of %d bytes\n", count);
+	iccom_drv_write_iicr_imbr(iccom_comm, IICR_SEND_DATA, count);
+
+	// wait for the sent data to be acked
+	ret = wait_event_interruptible_timeout(iccom_comm->write_q,
+					(iccom_comm->ack_received != 0),
+					iccom_hw->ack_timeout);
+	if (ret < 0) {
+		dev_err(iccom->dev, "[Err] Write operation interrupted\n");
+		ret = -EINTR;
+		goto Exit;
+	} else if (ret == 0) {
+		dev_err(iccom->dev, "[Err] Write operation timed out\n");
+		ret = -ETIMEDOUT;
+		goto Exit;
+	}
 
-	return ret;
-}
+	// wait for the reply
+	ret = wait_event_interruptible_timeout(iccom_comm->read_q,
+					(iccom_comm->valid_rx_data >= 1),
+					iccom->hw_info.read_timeout);
+
+	if (ret < 0) {
+		dev_err(iccom->dev, "[Err] Read operation interrupted");
+		goto Exit;
+	} else if (ret == 0) {
+		dev_err(iccom->dev, "[Err] Read operation timed out");
+		ret = -ENODATA;
+		goto Exit;
+	}
 
-static int32_t iccom_drv_ioctl(struct iccom_channel *channel,
-				int32_t req, void *arg)
-{
-	int32_t ret = 0;
-	struct iccom_communication_info *iccom_comm;
-	struct iccom_hardware_info *iccom_hw;
-	int32_t err_wait;
+	dev_dbg(iccom->dev, "Sent message was ACKed successfully\n");
 
-	pr_debug("%s: Start\n", __func__);
+Exit:
+	mutex_unlock(&iccom_comm->comm_mutex);
 
-	iccom_comm = (struct iccom_communication_info *)channel->priv;
-	iccom_hw = (struct iccom_hardware_info *)channel->iccom->priv;
+	if (ret < 0) {
+		iccom_drv_reset_registers(iccom_comm);
+		iccom_comm->ack_received = 0;
+		iccom_comm->valid_rx_data = 0;
+		memset(iccom_comm->rx_data_buff, 0,
+					iccom_comm->max_transaction_size);
 
-	switch (req) {
-	case ICCOM_IOC_CANCEL_RECEIVE:
-		disable_irq(iccom_hw->irq_no);
-		iccom_comm->close_flg = 1;
-		wake_up_interruptible(&iccom_comm->read_q);
-		/* Wait ACK send finish or trg timeout */
-		err_wait = wait_event_interruptible_timeout(
-					iccom_comm->ioctl_q,
-					(iccom_comm->close_flg == 2),
-					iccom_hw->trg_timeout);
-		if (err_wait == 0) {
-			pr_err("[Err]Wait all ACK send failed.\n");
-			ret = -ETIMEDOUT;
-		}
-		break;
-	default:
-		ret = -EINVAL;
-		pr_err("[Err]Invalid argument. req=%d\n", req);
-		break;
+		return ret;
 	}
 
-	pr_debug("%s: End ret = %d\n", __func__, ret);
-
-	return ret;
+	return count;
 }
 
-static int32_t iccom_drv_close(struct iccom_channel *channel)
+static int32_t iccom_drv_close(struct iccom *iccom)
 {
-	struct iccom *l_iccom;
 	struct iccom_communication_info *iccom_comm;
 	struct iccom_hardware_info *iccom_hw;
-	uintptr_t irq_flg = 0UL;
-
-	pr_debug("%s: Start\n", __func__);
-
-	l_iccom = channel->iccom;
-	iccom_comm = (struct iccom_communication_info *)channel->priv;
-	iccom_hw = (struct iccom_hardware_info *)l_iccom->priv;
-
-	if (iccom_comm->close_flg == 0) {
-		pr_debug("%s: disable_irq exec . iccom_comm->close_flg = %u\n",
-			__func__, iccom_comm->close_flg);
-		/* Process finalize but not call Iccom_lib_Final(). */
-		disable_irq(iccom_hw->irq_no);
-	}
 
-	spin_lock_irqsave(&iccom_comm->spinlock_mfis_info, irq_flg);
-	(void)memset(&iccom_comm->recv_index, 0,
-		sizeof(iccom_comm->recv_index));
-	(void)memset(&iccom_comm->recv_embr, 0, sizeof(iccom_comm->recv_embr));
-	iccom_comm->data_arrive = 0;
-	spin_unlock_irqrestore(&iccom_comm->spinlock_mfis_info, irq_flg);
-	wake_up_interruptible(&iccom_comm->read_q);
-	l_iccom->channel = NULL;
+	iccom_comm = iccom->comm_info;
+	iccom_hw = &(iccom->hw_info);
 
-	iccom_drv_release_channel(channel);
-	l_iccom->flg &= ~ICCOM_FLG_CH_OPEN;
+	disable_irq(iccom_hw->irq_no);
 
-	pr_debug("%s: End\n", __func__);
+	devm_kfree(iccom->dev, iccom->comm_info->rx_data_buff);
+	iccom_drv_release_comm(iccom_comm);
+	devm_kfree(iccom->dev, iccom->comm_info);
 
-	return ICCOM_OK;
+	return 0;
 }
 
-/* Interrupt handler */
-static irqreturn_t iccom_drv_isr(int irq, void *dev_id)
+static irqreturn_t iccom_drv_isr(int irq, void *iccom_ptr)
 {
-	uint32_t mfis_ctrl;
-	uint32_t mfis_msg;
-	enum iccom_cta_area cta_sw;
-	uint32_t snd_ack_flg;
+	struct iccom *iccom;
 	struct iccom_communication_info *iccom_comm = NULL;
-	struct iccom_channel *l_channel;
-	struct iccom *l_iccom;
-	uintptr_t irq_flg = 0UL;
-
-	pr_debug("%s: Start\n", __func__);
-
-	disable_irq_nosync(irq);
-
-	l_iccom = (struct iccom *)dev_id;
-	l_channel = l_iccom->channel;
-	/*
-	 * If the close function is called by the present function after
-	 * it has been called, to check here for iccom_channel there is a
-	 * possibility of NULL
-	 */
-	if (l_channel != NULL) {
-		iccom_comm = (struct iccom_communication_info *)l_channel->priv;
+	uint32_t mfis_eicr, mfis_embr;
+	uint8_t *src_addr;
+	int32_t ret;
+
+	iccom = (struct iccom *)iccom_ptr;
+	iccom_comm = iccom->comm_info;
+
+	if (iccom_comm == NULL) {
+		dev_err(iccom->dev, "[Err] Invalid pointer in IRQ function\n");
+		return IRQ_HANDLED;
 	}
-	/*
-	 * If the close function is called by the present function after
-	 * it has been called, to check here for iccom_communication_info
-	 * there is a possibility of NULL
-	 */
-	if (iccom_comm != NULL) {
-		mfis_ctrl = ioread32(iccom_comm->mfis_eicr_addr);
-
-		pr_debug("mfis ctrl :0x%X\n", mfis_ctrl);
-		snd_ack_flg = mfis_ctrl & ICCOM_CTRL_SND_ACK;
-		mfis_msg = ioread32(iccom_comm->mfis_embr_addr);
-
-		if (snd_ack_flg == 0U) {
-			cta_sw = (mfis_ctrl & ICCOM_CTRL_ACK_BUFF)
-				>> ICCOM_SHIFT_GET_ACK_AREA;
-			pr_debug("Recv Ack\n");
-			/* Check target message is not timeout. */
-			spin_lock_irqsave(&iccom_comm->spinlock_cta_flg,
-						irq_flg);
-			iccom_comm->cta_flg[cta_sw] = 0U;
-			spin_unlock_irqrestore(&iccom_comm->spinlock_cta_flg,
-						irq_flg);
-
-			if (iccom_comm->write_status[cta_sw]
-			     == ICCOM_WRITE_STATE_RECV_ACK) {
-					iccom_comm->ack_arrive[cta_sw] = 1U;
-					iccom_comm->ack_embr[cta_sw] = mfis_msg;
-					wake_up_interruptible(
-						&iccom_comm->write_q);
-			} else {
-				pr_err("[Err]No wait Area \n");
-			}
-		} else {
-			cta_sw = (mfis_ctrl & ICCOM_CTRL_SND_BUFF)
-				>> ICCOM_SHIFT_GET_RECV_AREA;
-			pr_debug("Recv Msg\n");
-			/* Check receiving message rule. */
-			if (iccom_comm->data_arrive < ICCOM_CTA_RBUF_NUM) {
-				/* Save MFIS info */
-				spin_lock_irqsave(
-					&iccom_comm->spinlock_mfis_info,
-					irq_flg);
-				iccom_comm->recv_index[iccom_comm->data_arrive]
-					= cta_sw;
-				iccom_comm->data_arrive++;
-				spin_unlock_irqrestore(
-					&iccom_comm->spinlock_mfis_info,
-					irq_flg);
-				iccom_comm->recv_eicr[cta_sw] = mfis_ctrl;
-				iccom_comm->recv_embr[cta_sw] = mfis_msg;
-				wake_up_interruptible(&iccom_comm->read_q);
-			}
+
+	mfis_eicr = ioread32(iccom_comm->mfis_eicr_addr);
+	mfis_embr = ioread32(iccom_comm->mfis_embr_addr);
+	
+	if (mfis_eicr & ICCOM_CTRL_ACK) {
+		dev_dbg(iccom->dev, "Received Ack\n");
+
+		iccom_comm->ack_received = 1;
+		wake_up_interruptible(&iccom_comm->write_q);
+
+		iccom_drv_write_iicr_imbr(iccom_comm, 0x00, 0x00);
+		iccom_drv_clear_eicr(iccom_comm);
+	} else if (mfis_eicr & ICCOM_CTRL_DATA) {
+		dev_dbg(iccom->dev, "Received message\n");
+
+		// copy data to the internal structure
+		src_addr = iccom_comm->upper_addr;
+		memcpy(iccom_comm->rx_data_buff, src_addr,
+				iccom_comm->max_transaction_size);
+		iccom_comm->valid_rx_data = mfis_embr;
+
+		iccom_drv_clear_eicr(iccom_comm);
+
+		// send ACK
+		dev_dbg(iccom->dev, "Send Ack\n");
+
+		iccom_drv_write_iicr_imbr(iccom_comm, IICR_SEND_ACK, 0x00);
+
+		ret = iccom_drv_poll_int_clear(iccom);
+		if (ret < 0) {
+			dev_err(iccom->dev, "[Err] Ack was not acked");
+			goto Exit;
 		}
-		iowrite32((mfis_ctrl & ICCOM_CTRL_CLEAR_INIT_BIT),
-			iccom_comm->mfis_eicr_addr);
+
+		wake_up_interruptible(&iccom_comm->read_q);
+	} else if (mfis_eicr & ICCOM_CTRL_INIT_COMPLETED) {
+		dev_dbg(iccom->dev, "Initialization completed ACK\n");
+		iccom_drv_clear_eicr(iccom_comm);
+	} else {
+		dev_err(iccom->dev, "Unknown interrupt reason\n");
+		iccom_drv_clear_eicr(iccom_comm);
 	}
-	enable_irq(irq);
 
-	pr_debug("%s: End\n", __func__);
+Exit:
 
 	return IRQ_HANDLED;
 }
